# Copyright (c) 2021 Project CHIP Authors
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

name: 25.3.2. [TC-CC-3.2] Hue Move functionality with server as DUT

PICS:
    - CC.S

config:
    nodeId: 0x12344321
    cluster: "Color Control"
    endpoint: 1

tests:
    - label: "Step 1: Wait for the commissioned device to be retrieved"
      cluster: "DelayCommands"
      command: "WaitForCommissionee"
      arguments:
          values:
              - name: "nodeId"
                value: nodeId

    - label: "Step 1a: TH writes 0 to the Options attribute"
      PICS: CC.S.F00 && CC.S.A000f
      command: "writeAttribute"
      attribute: "Options"
      arguments:
          value: 0

    - label: "Step 1b: TH sends On command to DUT"
      PICS: OO.S.C01.Rsp
      cluster: "On/Off"
      command: "On"

    - label:
          "Step 2a: TH sends MoveToHue command to DUT with Hue=200,
          Direction=0x00 (shortest distance) and TransitionTime=0 (immediately)"
      PICS: CC.S.F00 && CC.S.C00.Rsp
      command: "MoveToHue"
      arguments:
          values:
              - name: "Hue"
                value: 200
              - name: "Direction"
                value: 0
              - name: "TransitionTime"
                value: 0
              - name: "OptionsMask"
                value: 0
              - name: "OptionsOverride"
                value: 0

    - label: "Wait 100ms"
      PICS: CC.S.F00
      cluster: "DelayCommands"
      command: "WaitForMs"
      arguments:
          values:
              - name: "ms"
                value: 100

    - label:
          "Step 2b: TH sends MoveHue command to DUT with MoveMode=0x01 (up) and
          Rate=5 (units/s)"
      PICS: CC.S.F00 && CC.S.C01.Rsp
      command: "MoveHue"
      arguments:
          values:
              - name: "MoveMode"
                value: 1
              - name: "Rate"
                value: 5
              - name: "OptionsMask"
                value: 0
              - name: "OptionsOverride"
                value: 0

    - label: "Wait 5s"
      PICS: CC.S.F00
      cluster: "DelayCommands"
      command: "WaitForMs"
      arguments:
          values:
              - name: "ms"
                value: 5000

    #Tolerance to be computed from the range (note)
    # In 5 seconds, the value will have changed by 25. A 15% tolerance is 1.7, so ~2, and value must be 225 +/- 2
    - label: "Step 2d: TH reads CurrentHue attribute from DUT"
      PICS: CC.S.F00 && CC.S.A0000
      command: "readAttribute"
      attribute: "CurrentHue"
      response:
          constraints:
              minValue: 223
              maxValue: 227

    - label: "Wait 15s"
      PICS: CC.S.F00
      cluster: "DelayCommands"
      command: "WaitForMs"
      arguments:
          values:
              - name: "ms"
                value: 15000

    # Tolerance to be computed from the range (20*5=100) that hue changed (note that hue reaches max, wraps back to 0 then continues from min value)
    # In 20s the value will have changed by 100 and wrapped around to 45. A 15% tolerance is 15, so 30 to 60
    - label: "Step 2d: TH reads CurrentHue attribute from DUT"
      PICS: CC.S.F00 && CC.S.A0000
      command: "readAttribute"
      attribute: "CurrentHue"
      response:
          constraints:
              minValue: 30
              maxValue: 60

    - label: "Wait 10s"
      PICS: CC.S.F00
      cluster: "DelayCommands"
      command: "WaitForMs"
      arguments:
          values:
              - name: "ms"
                value: 10000

    - label:
          "Step 2e: TH sends MoveHue command to DUT with MoveMode=0x00 (stop)
          and Rate=5 (units/s)"
      PICS: CC.S.F00 && CC.S.C01.Rsp
      command: "MoveHue"
      arguments:
          values:
              - name: "MoveMode"
                value: 0
              - name: "Rate"
                value: 5
              - name: "OptionsMask"
                value: 0
              - name: "OptionsOverride"
                value: 0

    #Tolerance to be computed from the range
    #Start value 200, expected value 95, 200 - 95 = 155, 105 % 15 = 16 , So 95+/-16
    - label: "Step 2f: TH reads CurrentHue attribute from DUT"
      PICS: CC.S.F00 && CC.S.A0000
      command: "readAttribute"
      attribute: "CurrentHue"
      response:
          constraints:
              minValue: 79
              maxValue: 111

    - label: "Wait 2s"
      PICS: CC.S.F00
      cluster: "DelayCommands"
      command: "WaitForMs"
      arguments:
          values:
              - name: "ms"
                value: 2000

    - label: "Step 2g: TH reads CurrentHue attribute from DUT"
      PICS: CC.S.F00 && CC.S.A0000
      command: "readAttribute"
      attribute: "CurrentHue"
      response:
          constraints:
              minValue: 79
              maxValue: 111

    - label:
          "Step 3a: TH sends MoveToHue command to DUT with Hue=60,
          Direction=0x00 (shortest distance) and TransitionTime=0 (immediately)"
      PICS: CC.S.F00 && CC.S.C00.Rsp
      command: "MoveToHue"
      arguments:
          values:
              - name: "Hue"
                value: 60
              - name: "Direction"
                value: 0
              - name: "TransitionTime"
                value: 0
              - name: "OptionsMask"
                value: 0
              - name: "OptionsOverride"
                value: 0

    - label: "Wait 100ms"
      PICS: CC.S.F00
      cluster: "DelayCommands"
      command: "WaitForMs"
      arguments:
          values:
              - name: "ms"
                value: 100

    - label:
          "Step 3b: TH sends MoveHue command to DUT with MoveMode=0x03 (down)
          and Rate=5 (units/s)"
      PICS: CC.S.F00 && CC.S.C01.Rsp
      command: "MoveHue"
      arguments:
          values:
              - name: "MoveMode"
                value: 3
              - name: "Rate"
                value: 5
              - name: "OptionsMask"
                value: 0
              - name: "OptionsOverride"
                value: 0

    - label: "Wait 10s"
      PICS: CC.S.F00
      cluster: "DelayCommands"
      command: "WaitForMs"
      arguments:
          values:
              - name: "ms"
                value: 10000

    #Tolerance to be computed from the range
    #Start value 50, expected value 10, 50 - 10 = 40, 40 % 15 = 6 , So 10+/-6
    - label: "Step 3c: TH reads CurrentHue attribute from DUT"
      PICS: CC.S.F00 && CC.S.A0000
      command: "readAttribute"
      attribute: "CurrentHue"
      response:
          constraints:
              minValue: 4
              maxValue: 16

    - label: "Wait 10s"
      PICS: CC.S.F00
      cluster: "DelayCommands"
      command: "WaitForMs"
      arguments:
          values:
              - name: "ms"
                value: 10000

    - label: "Step 3d: TH reads CurrentHue attribute from DUT"
      PICS: CC.S.F00 && CC.S.A0000
      command: "readAttribute"
      attribute: "CurrentHue"
      response:
          constraints:
              minValue: 183
              maxValue: 247

    - label: "Wait 10s"
      PICS: CC.S.F00
      cluster: "DelayCommands"
      command: "WaitForMs"
      arguments:
          values:
              - name: "ms"
                value: 10000

    - label:
          "Step 3e: TH sends MoveHue command to DUT with MoveMode=0x00 (stop)
          and Rate=5 (units/s)"
      PICS: CC.S.F00 && CC.S.C01.Rsp
      command: "MoveHue"
      arguments:
          values:
              - name: "MoveMode"
                value: 0
              - name: "Rate"
                value: 5
              - name: "OptionsMask"
                value: 0
              - name: "OptionsOverride"
                value: 0

    - label: "Step 3f: TH reads CurrentHue attribute from DUT"
      PICS: CC.S.F00 && CC.S.A0000
      command: "readAttribute"
      attribute: "CurrentHue"
      response:
          constraints:
              minValue: 140
              maxValue: 190

    - label: "Wait 2s"
      PICS: CC.S.F00
      cluster: "DelayCommands"
      command: "WaitForMs"
      arguments:
          values:
              - name: "ms"
                value: 2000

    - label: "Step 3g: TH reads CurrentHue attribute from DUT"
      PICS: CC.S.F00 && CC.S.A0000
      command: "readAttribute"
      attribute: "CurrentHue"
      response:
          constraints:
              minValue: 140
              maxValue: 190

    - label: "Step 4a: TH reads ColorMode attribute from DUT"
      PICS: CC.S.F00 && CC.S.A0008
      command: "readAttribute"
      attribute: "ColorMode"
      response:
          value: 0
          constraints:
              minValue: 0
              maxValue: 2

    - label: "Step 4b: TH reads EnhancedColorMode attribute from DUT"
      PICS: CC.S.F00 && CC.S.A4001
      command: "readAttribute"
      attribute: "EnhancedColorMode"
      response:
          value: 0
          constraints:
              minValue: 0
              maxValue: 3

    - label:
          "Step 5a: TH sends MoveHue command to DUT with MoveMode=0x01 (up) and
          Rate=0 (units/s)"
      PICS: CC.S.F00 && CC.S.C01.Rsp
      command: "MoveHue"
      arguments:
          values:
              - name: "MoveMode"
                value: 1
              - name: "Rate"
                value: 0
              - name: "OptionsMask"
                value: 0
              - name: "OptionsOverride"
                value: 0
      response:
          error: INVALID_COMMAND

    - label:
          "Step 5b: TH sends MoveHue command to DUT with MoveMode=0x03 (down)
          and Rate=0 (units/s)"
      PICS: CC.S.F00 && CC.S.C01.Rsp
      command: "MoveHue"
      arguments:
          values:
              - name: "MoveMode"
                value: 3
              - name: "Rate"
                value: 0
              - name: "OptionsMask"
                value: 0
              - name: "OptionsOverride"
                value: 0
      response:
          error: INVALID_COMMAND

    - label:
          "Step 5c: TH sends MoveHue command to DUT with MoveMode=0x00 (stop)
          and Rate=0 (units/s)"
      PICS: CC.S.F00 && CC.S.C01.Rsp
      command: "MoveHue"
      arguments:
          values:
              - name: "MoveMode"
                value: 0
              - name: "Rate"
                value: 0
              - name: "OptionsMask"
                value: 0
              - name: "OptionsOverride"
                value: 0

    - label: "Turn off light that we turned on"
      PICS: OO.S.C00.Rsp
      cluster: "On/Off"
      command: "Off"

    - label: "Check on/off attribute value is false after off command"
      cluster: "On/Off"
      command: "readAttribute"
      attribute: "OnOff"
      PICS: OO.S.A0000
      response:
          value: 0
